Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_crs.F90	(revision 6772)
@@ -35,4 +35,5 @@
    USE crs
    USE iom
+   USE ieee_arithmetic
 
    IMPLICIT NONE
@@ -168,8 +169,6 @@
                !                                      ! bound the slopes: abs(zw.)<= 1/100 and zb..<0
                !                                      ! + kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-               zbu = MIN(  zbu, -100._wp* ABS( zau ) , -7.e+3_wp/e3u_max_crs(ji,jj,jk)* ABS( zau )  )
-               zbv = MIN(  zbv, -100._wp* ABS( zav ) , -7.e+3_wp/e3v_max_crs(ji,jj,jk)* ABS( zav )  )
-               !cc zbu = MIN(  zbu, -100._wp* ABS( zau ) , -7.e+3_wp/e3u_crs(ji,jj,jk)* ABS( zau )  )
-               !cc zbv = MIN(  zbv, -100._wp* ABS( zav ) , -7.e+3_wp/e3v_crs(ji,jj,jk)* ABS( zav )  )
+               zbu = MIN(  zbu, -100._wp* ABS( zau ) , -7.e+3_wp/fse3u_max_crs(ji,jj,jk)* ABS( zau )  )
+               zbv = MIN(  zbv, -100._wp* ABS( zav ) , -7.e+3_wp/fse3v_max_crs(ji,jj,jk)* ABS( zav )  )
                !                                      ! uslp and vslp output in zwz and zww, resp.
                zfi = MAX( omlmask(ji,jj,jk), omlmask(ji+1,jj,jk) )
@@ -177,9 +176,9 @@
                zwz(ji,jj,jk) = ( ( 1. - zfi) * zau / ( zbu - zeps )                                              &
                   &                   + zfi  * uslpml(ji,jj)                                                     &
-                  &                          * 0.5_wp * ( gdept_crs(ji+1,jj,jk)+gdept_crs(ji,jj,jk) - e3u_max_crs(ji,jj,1) )   &
+                  &                          * 0.5_wp * ( fsdept_crs(ji+1,jj,jk)+fsdept_crs(ji,jj,jk) - fse3u_max_crs(ji,jj,1) )   &
                   &                          / MAX( hmlpt_crs(ji,jj), hmlpt_crs(ji+1,jj), 5._wp ) ) * umask_crs(ji,jj,jk)
                zww(ji,jj,jk) = ( ( 1. - zfj) * zav / ( zbv - zeps )                                              &
                   &                   + zfj  * vslpml(ji,jj)                                                     &
-                  &                          * 0.5_wp * ( gdept_crs(ji,jj+1,jk)+ gdept_crs(ji,jj,jk)-e3v_max_crs(ji,jj,1) )   &
+                  &                          * 0.5_wp * ( fsdept_crs(ji,jj+1,jk)+ fsdept_crs(ji,jj,jk)-fse3v_max_crs(ji,jj,1) )   &
                   &                          / MAX( hmlpt_crs(ji,jj), hmlpt_crs(ji,jj+1), 5. ) ) * vmask_crs(ji,jj,jk)
 !!gm  modif to suppress omlmask.... (as in Griffies case)
@@ -196,6 +195,4 @@
       END DO
       CALL crs_lbc_lnk( zwz, 'U', -1. )   ;   CALL crs_lbc_lnk( zww, 'V', -1. )      ! lateral boundary conditions
-      CALL iom_put("zwz_crs",zwz)
-      CALL iom_put("zww_crs",zww)
       !
       !                                            !* horizontal Shapiro filter
@@ -262,9 +259,9 @@
                !                                        ! bound the slopes: abs(zw.)<= 1/100 and zb..<0.
                !                                        ! + kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-               zbi = MIN( zbw ,- 100._wp* ABS( zai ) , -7.e+3_wp/e3w_max_crs(ji,jj,jk)* ABS( zai )  )
-               zbj = MIN( zbw , -100._wp* ABS( zaj ) , -7.e+3_wp/e3w_max_crs(ji,jj,jk)* ABS( zaj )  )
+               zbi = MIN( zbw ,- 100._wp* ABS( zai ) , -7.e+3_wp/fse3w_max_crs(ji,jj,jk)* ABS( zai )  )
+               zbj = MIN( zbw , -100._wp* ABS( zaj ) , -7.e+3_wp/fse3w_max_crs(ji,jj,jk)* ABS( zaj )  )
                !                                        ! wslpi and wslpj with ML flattening (output in zwz and zww, resp.)
                zfk = MAX( omlmask(ji,jj,jk), omlmask(ji,jj,jk-1) )   ! zfk=1 in the ML otherwise zfk=0
-               zck = gdepw_crs(ji,jj,jk) / MAX( hmlp_crs(ji,jj), 10._wp )
+               zck = fsdepw_crs(ji,jj,jk) / MAX( hmlp_crs(ji,jj), 10._wp )
                zwz(ji,jj,jk) = (  zai / ( zbi - zeps ) * ( 1._wp - zfk ) + zck * wslpiml(ji,jj) * zfk  ) * tmask_crs(ji,jj,jk)
                zww(ji,jj,jk) = (  zaj / ( zbj - zeps ) * ( 1._wp - zfk ) + zck * wslpjml(ji,jj) * zfk  ) * tmask_crs(ji,jj,jk)
@@ -333,9 +330,4 @@
       !
       CALL iom_swap( "nemo_crs" )    ! swap on the coarse grid
-      CALL iom_put("zgru_crs",zgru)
-      CALL iom_put("zgrv_crs",zgrv)
-      CALL iom_put("zdzr_crs",zdzr)
-      CALL iom_put("zwz_crs",zwz)
-      CALL iom_put("zww_crs",zww)
       CALL iom_put("uslp_crs",uslp_crs)
       CALL iom_put("vslp_crs",vslp_crs)
@@ -411,6 +403,6 @@
       !-----------------------------------------------------------------------
       !
-      DO jj = 2, jpj_crsm1
-         DO ji = 2, jpi_crsm1
+      DO jj = 2, nldi_crs
+         DO ji = 2, nldj_crs
             !                        !==   Slope at u- & v-points just below the Mixed Layer   ==!
             !
@@ -425,6 +417,6 @@
             !                        !- bound the slopes: abs(zw.)<= 1/100 and zb..<0
             !                           kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-            zbu = MIN(  zbu , -100._wp* ABS( zau ) , -7.e+3_wp/e3u_max_crs(ji,jj,iku)* ABS( zau )  )
-            zbv = MIN(  zbv , -100._wp* ABS( zav ) , -7.e+3_wp/e3v_max_crs(ji,jj,ikv)* ABS( zav )  )
+            zbu = MIN(  zbu , -100._wp* ABS( zau ) , -7.e+3_wp/fse3u_max_crs(ji,jj,iku)* ABS( zau )  )
+            zbv = MIN(  zbv , -100._wp* ABS( zav ) , -7.e+3_wp/fse3v_max_crs(ji,jj,ikv)* ABS( zav )  )
             !                        !- Slope at u- & v-points (uslpml, vslpml)
             uslpml(ji,jj) = zau / ( zbu - zeps ) * umask_crs(ji,jj,iku)
@@ -448,6 +440,6 @@
             !                        !- bound the slopes: abs(zw.)<= 1/100 and zb..<0.
             !                           kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-            zbi = MIN(  zbw , -100._wp* ABS( zai ) , -7.e+3_wp/e3w_max_crs(ji,jj,ik)* ABS( zai )  )
-            zbj = MIN(  zbw , -100._wp* ABS( zaj ) , -7.e+3_wp/e3w_max_crs(ji,jj,ik)* ABS( zaj )  )
+            zbi = MIN(  zbw , -100._wp* ABS( zai ) , -7.e+3_wp/fse3w_max_crs(ji,jj,ik)* ABS( zai )  )
+            zbj = MIN(  zbw , -100._wp* ABS( zaj ) , -7.e+3_wp/fse3w_max_crs(ji,jj,ik)* ABS( zaj )  )
             !                        !- i- & j-slope at w-points (wslpiml, wslpjml)
             wslpiml(ji,jj) = zai / ( zbi - zeps ) * tmask_crs (ji,jj,ik)
@@ -493,9 +485,6 @@
          !
       ELSE                             ! Madec operator : slopes at u-, v-, and w-points
-         ALLOCATE( uslp_crs(jpi_crs,jpj_crs,jpk) , vslp_crs(jpi_crs,jpj_crs,jpk) , & 
-                 & wslpi_crs(jpi_crs,jpj_crs,jpk) , wslpj_crs(jpi_crs,jpj_crs,jpk) ,  &
-                 & omlmask(jpi_crs,jpj_crs,jpk) ,  &
-                 & uslpml(jpi_crs,jpj_crs)   ,  vslpml(jpi_crs,jpj_crs)  , & 
-                 & wslpiml(jpi_crs,jpj_crs)   , wslpjml(jpi_crs,jpj_crs) , STAT=ierr )
+         ALLOCATE( uslp_crs(jpi_crs,jpj_crs,jpk) , vslp_crs(jpi_crs,jpj_crs,jpk) , wslpi_crs(jpi_crs,jpj_crs,jpk) , wslpj_crs(jpi_crs,jpj_crs,jpk) ,  &
+            &   omlmask(jpi_crs,jpj_crs,jpk) , uslpml(jpi_crs,jpj_crs)   , vslpml(jpi_crs,jpj_crs)    , wslpiml(jpi_crs,jpj_crs)   , wslpjml(jpi_crs,jpj_crs) , STAT=ierr )
          IF( ierr > 0 )   CALL ctl_stop( 'STOP', 'ldf_slp_init : unable to allocate Madec operator slope ' )
 
@@ -520,15 +509,11 @@
                DO jj = 2, jpj_crsm1
                   DO ji = 2, jpi_crsm1   ! vector opt.
-                  !cbr uslp_crs (ji,jj,jk) = -1./e1u_crs(ji,jj) * ( gdept_crs(ji+1,jj,jk) - gdept_crs(ji ,jj ,jk) ) * umask_crs(ji,jj,jk)
-                  !vslp_crs (ji,jj,jk) = -1./e2v_crs(ji,jj) * ( gdept_crs(ji,jj+1,jk) - gdept_crs(ji ,jj ,jk) ) * vmask_crs(ji,jj,jk)
-                  !wslpi_crs(ji,jj,jk) = -1./e1t_crs(ji,jj) * ( gdepw_crs(ji+1,jj,jk) - gdepw_crs(ji-1,jj,jk) ) * tmask_crs(ji,jj,jk) * 0.5
-                  !wslpj_crs(ji,jj,jk) = -1./e2t_crs(ji,jj) * ( gdepw_crs(ji,jj+1,jk) - gdepw_crs(ji,jj-1,jk) ) * tmask_crs(ji,jj,jk) * 0.5
-                  uslp_crs (ji,jj,jk) = -1. * ( gdept_crs(ji+1,jj,jk) - gdept_crs(ji ,jj ,jk) ) * umask_crs(ji,jj,jk)
+                  uslp_crs (ji,jj,jk) = -1. * ( fsdept_crs(ji+1,jj,jk) - fsdept_crs(ji ,jj ,jk) ) * umask_crs(ji,jj,jk)
                   IF( e1u_crs(ji,jj) .NE. 0._wp ) uslp_crs (ji,jj,jk) = uslp_crs (ji,jj,jk) / e1u_crs(ji,jj)
-                  vslp_crs (ji,jj,jk) = -1. * ( gdept_crs(ji,jj+1,jk) - gdept_crs(ji ,jj ,jk) ) * vmask_crs(ji,jj,jk)
+                  vslp_crs (ji,jj,jk) = -1. * ( fsdept_crs(ji,jj+1,jk) - fsdept_crs(ji ,jj ,jk) ) * vmask_crs(ji,jj,jk)
                   IF( e2v_crs(ji,jj) .NE. 0._wp ) vslp_crs (ji,jj,jk) = vslp_crs (ji,jj,jk) / e2v_crs(ji,jj)
-                  wslpi_crs(ji,jj,jk) = -1. * ( gdepw_crs(ji+1,jj,jk) - gdepw_crs(ji-1,jj,jk) ) * tmask_crs(ji,jj,jk) * 0.5
+                  wslpi_crs(ji,jj,jk) = -1. * ( fsdepw_crs(ji+1,jj,jk) - fsdepw_crs(ji-1,jj,jk) ) * tmask_crs(ji,jj,jk) * 0.5
                   IF( e1t_crs(ji,jj) .NE. 0._wp ) wslpi_crs(ji,jj,jk) =  wslpi_crs(ji,jj,jk) / e1t_crs(ji,jj)
-                  wslpj_crs(ji,jj,jk) = -1. * ( gdepw_crs(ji,jj+1,jk) - gdepw_crs(ji,jj-1,jk) ) * tmask_crs(ji,jj,jk) * 0.5
+                  wslpj_crs(ji,jj,jk) = -1. * ( fsdepw_crs(ji,jj+1,jk) - fsdepw_crs(ji,jj-1,jk) ) * tmask_crs(ji,jj,jk) * 0.5
                   IF( e2t_crs(ji,jj) .NE. 0._wp ) wslpj_crs(ji,jj,jk) = wslpj_crs(ji,jj,jk) / e2t_crs(ji,jj)
                   END DO
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_crs.F90	(revision 6772)
@@ -8,5 +8,5 @@
    !!             2.0  ! 2005-11  (G. Madec)  
    !!----------------------------------------------------------------------
-
+#if defined key_top && defined key_crs
    !!----------------------------------------------------------------------
    !!   ldf_tra_init : initialization, namelist read, and parameters control
@@ -88,3 +88,10 @@
 
    !!======================================================================
+#else
+   PUBLIC   ldf_tra_crs_init
+CONTAINS
+   SUBROUTINE ldf_tra_crs_init
+   END SUBROUTINE ldf_tra_crs_init
+
+#endif
 END MODULE ldftra_crs
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 6772)
@@ -44,9 +44,10 @@
    USE sbc_ice         ! Surface boundary condition: ice fields
    USE lib_fortran     ! to use key_nosignedzero
+   USE sbcapr
 #if defined key_lim3
    USE ice, ONLY       : u_ice, v_ice, jpl, pfrld, a_i_b
    USE limthd_dh       ! for CALL lim_thd_snwblow
 #elif defined key_lim2
-   USE ice_2, ONLY     : u_ice, v_ice
+   USE ice_2, ONLY     : u_ice, v_ice, pfrld
    USE par_ice_2
 #endif
@@ -83,4 +84,6 @@
    REAL(wp), PARAMETER ::   Cice =    1.4e-3      ! iovi 1.63e-3     ! transfer coefficient over ice
    REAL(wp), PARAMETER ::   albo =    0.066       ! ocean albedo assumed to be constant
+   REAL(wp), PARAMETER ::   rgas =  287.1         ! gas const. dry air (J/kg/K)
+   REAL(wp), PARAMETER ::   rvap =  461.51        ! gas const. vapour  (J/kg/K)
 
    !                                  !!* Namelist namsbc_core : CORE bulk parameters
@@ -91,4 +94,11 @@
    REAL(wp) ::   rn_zqt      ! z(q,t) : height of humidity and temperature measurements
    REAL(wp) ::   rn_zu       ! z(u)   : height of wind measurements
+   !
+   LOGICAL  ::   ln_tair_celsius  !: logical flag for Read Tair: Tair in NEMO is Kelvin
+   LOGICAL  ::   ln_humi_rel      !: logical flag for Read relative humidity (T) or specific humidity (F)
+   LOGICAL  ::   ln_cohum_arc     !: logical flag for Correction of Humidity in the Arctic Ocean
+   LOGICAL  ::   ln_cotair_arc    !: logical flag for Correction of Air Temperature in the Arctic Ocean
+   LOGICAL  ::   ln_corad_antar   !: logical flag for Correction of radiatives fluxes in the Southern Ocean
+
 
    !! * Substitutions
@@ -143,4 +153,10 @@
       INTEGER  ::   ios      ! Local integer output status for namelist read
       !
+      INTEGER  ::   ji,jj
+      REAL(wp) ::   zzlat, zzlat1, zzlat2, zfm, zfrld
+      REAL(wp) ::   zmin,zmax
+      REAL(wp), DIMENSION(:,:), POINTER :: xyt,z_qsr,z_qlw,z_qsr1,z_qlw1, z_hum, z_tair
+      REAL(wp), DIMENSION(:,:), POINTER :: zqsr_lr, zqsr_hr, zqlw_lr, zqlw_hr
+     
       CHARACTER(len=100) ::  cn_dir   !   Root directory for location of core files
       TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i     ! array of namelist informations on the fields to read
@@ -151,7 +167,12 @@
          &                  sn_wndi, sn_wndj, sn_humi  , sn_qsr ,           &
          &                  sn_qlw , sn_tair, sn_prec  , sn_snow,           &
-         &                  sn_tdif, rn_zqt,  rn_zu
+         &                  sn_tdif, rn_zqt,  rn_zu , ln_tair_celsius,   &
+         &                  ln_humi_rel  , ln_cohum_arc,      &
+         &                  ln_cotair_arc, ln_corad_antar
+
       !!---------------------------------------------------------------------
       !
+      CALL wrk_alloc( jpi,jpj, xyt,z_qsr,z_qlw,z_qsr1,z_qlw1, z_hum, z_tair )
+      CALL wrk_alloc( jpi,jpj, zqsr_lr, zqsr_hr, zqlw_lr, zqlw_hr )
       !                                         ! ====================== !
       IF( kt == nit000 ) THEN                   !  First call kt=nit000  !
@@ -194,4 +215,13 @@
          CALL fld_fill( sf, slf_i, cn_dir, 'sbc_blk_core', 'flux formulation for ocean surface boundary condition', 'namsbc_core' )
          !
+         !
+         IF(lwp) WRITE(numout,*) 'sbc_blk_core: jfld = ',jfld
+         IF( ln_cohum_arc   ) CALL ctl_warn( 'sbc_blk_core: correction of humidity in arctic' )
+         IF( ln_cotair_arc  ) CALL ctl_warn( 'sbc_blk_core: correction of air temperature in arctic' )
+         IF( ln_corad_antar ) CALL ctl_warn( 'sbc_blk_core: correction of short radiation in antartic' )
+         IF( ln_humi_rel    ) CALL ctl_warn( 'sbc_blk_core: use relative humidity instead of specific humidity')
+         IF( ln_tair_celsius) CALL ctl_warn( 'sbc_blk_core: Tair is read in Celsius')
+         IF(lwp) WRITE(numout,*) 'sbc_blk_core: rn_pfac = ',rn_pfac
+         !
          sfx(:,:) = 0._wp                          ! salt flux; zero unless ice is present (computed in limsbc(_2).F90)
          !
@@ -199,4 +229,102 @@
 
       CALL fld_read( kt, nn_fsbc, sf )             ! input fields provided at the current time-step
+
+      !=========================================
+      !  ONLINE CORRECTIONS
+      !=========================================
+      !
+      ! Correction of Tair
+      !
+      IF( ln_tair_celsius .AND. MOD( kt-1, nn_fsbc ) == 0 ) THEN
+         sf(jp_tair)%fnow = sf(jp_tair)%fnow + 273.15_wp  ! Conversion of the Temperature °C --> Kelvin
+      ENDIF
+      !
+      ! Correction of SW and LW in the Southern Ocean
+      !
+      IF( ln_corad_antar .AND. .NOT. sf(jp_qsr)%ln_tint .AND. MOD( kt-1, 86400/INT(rdt) ) == 0 ) THEN
+         z_qsr(:,:) = 0.8 * sf(jp_qsr)%fnow(:,:,1)
+         xyt(:,:) = 0.e0 ; zzlat1 = -65. ; zzlat2 = -60.
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zzlat = gphit(ji,jj)
+               IF( zzlat >= zzlat1 .AND. zzlat <= zzlat2 ) THEN
+                  xyt(ji,jj) = (zzlat2-zzlat)/(zzlat2-zzlat1)
+               ELSE IF ( zzlat < zzlat1 ) THEN
+                  xyt(ji,jj) = 1
+               ENDIF
+            END DO
+         END DO
+         IF(lwp) WRITE(numout,*) 'Correc ln_corad_antar'
+         z_qsr1(:,:) = z_qsr(:,:) * xyt(:,:) + ( 1.0 - xyt(:,:) ) * sf(jp_qsr)%fnow(:,:,1)
+         sf(jp_qsr)%fnow(:,:,1) = z_qsr1(:,:)
+      ENDIF
+
+      IF( MOD( kt-1, nn_fsbc ) == 0 )THEN
+         !
+         IF ( nmonth >= 5 .AND. nmonth <= 9 ) THEN
+            !
+            ! Correction of Humidity in the Arctic Ocean
+            !
+            IF( ln_cohum_arc ) THEN
+               z_hum(:,:) = 0.85 * sf(jp_humi)%fnow(:,:,1)
+               xyt(:,:) = 0.e0 ; zzlat1 = 78. ; zzlat2 = 82.
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     zzlat = gphit(ji,jj)
+#if defined key_lim2 ||  defined key_lim3 
+                     IF ( ALLOCATED(pfrld) ) THEN ; zfrld = pfrld(ji,jj) ; ELSE ; zfrld = 0 ; ENDIF
+#endif
+                     IF( zzlat >= zzlat1 .AND. zzlat <= zzlat2 .AND. zfrld < 0.85 ) THEN
+                        xyt(ji,jj) = ( zzlat - zzlat1 ) / ( zzlat2 - zzlat1 )
+                     ELSE IF ( zzlat > zzlat2 .AND. zfrld < 0.85 ) THEN
+                        xyt(ji,jj) = 1._wp
+                     ENDIF
+                  ENDDO
+               ENDDO
+               IF(lwp) WRITE(numout,*) 'Correc ln_cohum_arc'
+               sf(jp_humi)%fnow(:,:,1) = z_hum(:,:) * xyt(:,:) + ( 1.0 - xyt(:,:) ) * sf(jp_humi)%fnow(:,:,1)
+            ENDIF
+            !
+            ! Correction of Air Temperature in the Arctic Ocean
+            !
+            IF( ln_cotair_arc ) THEN
+               z_tair(:,:) = sf(jp_tair)%fnow(:,:,1) - 2.0
+               xyt(:,:) = 0.e0 ; zzlat1 = 78. ; zzlat2 = 82.
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     zzlat = gphit(ji,jj)
+#if defined key_lim2 ||  defined key_lim3 
+                     IF( ALLOCATED(pfrld) ) THEN ; zfrld = pfrld(ji,jj) ; ELSE ; zfrld=0 ; ENDIF
+#endif
+                     IF( zzlat >= zzlat1 .AND. zzlat <= zzlat2 .AND. zfrld < 0.85 ) THEN
+                        xyt(ji,jj) = ( zzlat - zzlat1 ) / ( zzlat2 - zzlat1 )
+                     ELSE IF( zzlat > zzlat2 .AND. zfrld < 0.85 ) THEN
+                        xyt(ji,jj) = 1._wp
+                     ENDIF
+                  END DO
+               ENDDO
+               IF(lwp) WRITE(numout,*) 'Correc ln_cotair_arc'
+               sf(jp_tair)%fnow(:,:,1) = z_tair(:,:) * xyt(:,:) + ( 1.0 - xyt(:,:) ) * sf(jp_tair)%fnow(:,:,1)
+            ENDIF
+            !
+         ENDIF ! 5 <= nmonth <= 9
+
+         !
+      ENDIF ! IF MOD( kt-1, nn_fsbc )
+
+      DO jj=1,jpj
+         DO ji=1,jpi
+            sf(jp_humi)%fnow(ji,jj,1) = MAX( MIN( sf(jp_humi)%fnow(ji,jj,1) ,1.0 ) , 0.0 )
+            sf(jp_prec)%fnow(ji,jj,1) = MAX(      sf(jp_prec)%fnow(ji,jj,1) ,0.0 )
+            sf(jp_qsr )%fnow(ji,jj,1) = MAX(      sf(jp_qsr )%fnow(ji,jj,1) ,0.0 )
+            sf(jp_qlw )%fnow(ji,jj,1) = MAX(      sf(jp_qlw )%fnow(ji,jj,1) ,0.0 )
+         ENDDO
+      END DO
+
+      !
+      !=========================================
+      ! END OF ONLINE CORRECTIONS
+      !=========================================
+      !
 
       !                                            ! compute the surface ocean fluxes using CORE bulk formulea
@@ -215,4 +343,7 @@
       ENDIF
 #endif
+      !
+      CALL wrk_dealloc( jpi,jpj, xyt,z_qsr,z_qlw,z_qsr1,z_qlw1, z_hum, z_tair )
+      CALL wrk_dealloc( jpi,jpj, zqsr_lr, zqsr_hr, zqlw_lr, zqlw_hr )
       !
    END SUBROUTINE sbc_blk_core
@@ -257,4 +388,6 @@
       REAL(wp), DIMENSION(:,:), POINTER ::   zt_zu             ! air temperature at wind speed height
       REAL(wp), DIMENSION(:,:), POINTER ::   zq_zu             ! air spec. hum.  at wind speed height
+      REAL(wp), DIMENSION(:,:), POINTER ::   zqatm , zpatm     ! specific humidity and mean sea level pressure (Pa)
+      REAL(wp) :: vt, vp, vq, zqa, zq0, zq1, zq2, zee
       !!---------------------------------------------------------------------
       !
@@ -262,5 +395,5 @@
       !
       CALL wrk_alloc( jpi,jpj, zwnd_i, zwnd_j, zqsatw, zqlw, zqsb, zqla, zevap )
-      CALL wrk_alloc( jpi,jpj, Cd, Ch, Ce, zst, zt_zu, zq_zu )
+      CALL wrk_alloc( jpi,jpj, Cd, Ch, Ce, zst, zt_zu, zq_zu ,zqatm, zpatm )
       !
       ! local scalars ( place there for vector optimisation purposes)
@@ -314,7 +447,30 @@
       ! ... specific humidity at SST and IST
       zqsatw(:,:) = zcoef_qsatw * EXP( -5107.4 / zst(:,:) )
-
+      !
+      IF ( ln_humi_rel ) THEN
+         zq0    = rvap / rgas - 1.0
+         zq1    = rgas / rvap
+         zq2    = 1.0 - zq1
+         zpatm(:,:) = 100800.                   ! atmospheric pressure (assumed constant  here)
+         IF ( ln_apr_dyn ) zpatm(:,:) = apr(:,:)
+         DO jj = 1 , jpj
+            DO ji = 1 , jpi
+               vt  = sf(jp_tair)%fnow(ji,jj,1) - rt0  ! air temperature (Celsius)
+               vp  = zpatm(ji,jj) / 100.              ! mean sea level pressure (mb or hPa)
+               vq  = sf(jp_humi)%fnow(ji,jj,1)        ! relative humidity (fraction of 1)
+               ! Convert RH at the air/sea interface in specific humidity (kg/kg)
+               ! Teten's formula for qsat (mb)
+               zqa = ( 1.0007 + 3.46e-6 * vp) * 6.1121 * EXP( 17.502 * vt / ( 240.97+vt ) )
+               zee = zqa * vq                         ! vapour partial pressure (mb)
+               vq  = zq1 * zee / ( vp - zq2 * zee )   ! specific humidity (kg/kg)
+               zqatm(ji,jj) = vq
+            ENDDO
+         ENDDO
+      ELSE
+         zqatm(:,:)=sf(jp_humi)%fnow(:,:,1)
+      ENDIF
+      !
       ! ... NCAR Bulk formulae, computation of Cd, Ch, Ce at T-point :
-      CALL turb_core_2z( rn_zqt, rn_zu, zst, sf(jp_tair)%fnow, zqsatw, sf(jp_humi)%fnow, wndm,   &
+      CALL turb_core_2z( rn_zqt, rn_zu, zst, sf(jp_tair)%fnow, zqsatw, zqatm, wndm,   &
          &               Cd, Ch, Ce, zt_zu, zq_zu )
     
@@ -354,5 +510,6 @@
       IF( ABS( rn_zu - rn_zqt) < 0.01_wp ) THEN
          !! q_air and t_air are (or "are almost") given at 10m (wind reference height)
-         zevap(:,:) = rn_efac*MAX( 0._wp,     rhoa*Ce(:,:)*( zqsatw(:,:) - sf(jp_humi)%fnow(:,:,1) )*wndm(:,:) ) ! Evaporation
+         !zevap(:,:) = rn_efac*MAX( 0._wp,     rhoa*Ce(:,:)*( zqsatw(:,:) - sf(jp_humi)%fnow(:,:,1) )*wndm(:,:) ) ! Evaporation
+          zevap(:,:) = rn_efac*MAX( 0._wp,     rhoa*Ce(:,:)*( zqsatw(:,:) - zqatm(:,:)              )*wndm(:,:) ) ! Evaporation
          zqsb (:,:) =                     cpa*rhoa*Ch(:,:)*( zst   (:,:) - sf(jp_tair)%fnow(:,:,1) )*wndm(:,:)   ! Sensible Heat
       ELSE
@@ -414,5 +571,5 @@
       !
       CALL wrk_dealloc( jpi,jpj, zwnd_i, zwnd_j, zqsatw, zqlw, zqsb, zqla, zevap )
-      CALL wrk_dealloc( jpi,jpj, Cd, Ch, Ce, zst, zt_zu, zq_zu )
+      CALL wrk_dealloc( jpi,jpj, Cd, Ch, Ce, zst, zt_zu, zq_zu, zqatm, zpatm )
       !
       IF( nn_timing == 1 )  CALL timing_stop('blk_oce_core')
@@ -437,5 +594,5 @@
       REAL(wp) ::             zwndi_t , zwndj_t               ! relative wind components at T-point
       !!---------------------------------------------------------------------
-      !
+
       IF( nn_timing == 1 )  CALL timing_start('blk_ice_core_tau')
       !
@@ -530,4 +687,5 @@
       REAL(wp) ::   zcoef_dqlw, zcoef_dqla, zcoef_dqsb
       REAL(wp) ::   zztmp, z1_lsub                               ! temporary variable
+      REAL(wp) ::   ztamr,zmt1,zmt2,zmt3,zev,zes
       !!
       REAL(wp), DIMENSION(:,:,:), POINTER ::   z_qlw             ! long wave heat flux over ice
@@ -536,4 +694,5 @@
       REAL(wp), DIMENSION(:,:,:), POINTER ::   z_dqsb            ! sensible  heat sensitivity over ice
       REAL(wp), DIMENSION(:,:)  , POINTER ::   zevap, zsnw       ! evaporation and snw distribution after wind blowing (LIM3)
+      REAL(wp), DIMENSION(:,:)  , POINTER ::   zqatm, zpatm , ztatm            ! specific humidity
       !!---------------------------------------------------------------------
       !
@@ -541,4 +700,25 @@
       !
       CALL wrk_alloc( jpi,jpj,jpl, z_qlw, z_qsb, z_dqlw, z_dqsb ) 
+      CALL wrk_alloc( jpi,jpj, zqatm, zpatm, ztatm )
+ 
+     IF ( ln_humi_rel ) THEN
+         zpatm(:,:) = 100800.                   ! atmospheric pressure (assumed constant here)
+         IF (ln_apr_dyn) zpatm(:,:) = apr(:,:)
+         DO jj=1,jpj
+            DO ji=1,jpi
+               ztatm (ji,jj) = sf(jp_tair)%fnow(ji,jj,1)                   ! air temperature in Kelvins
+               ztamr = ztatm(ji,jj) - rtt                                  ! Saturation water vapour
+               zmt1  = SIGN( 17.269,  ztamr )
+               zmt2  = SIGN( 21.875,  ztamr )
+               zmt3  = SIGN( 28.200, -ztamr )
+               zes   = 611.0 * EXP(  ABS( ztamr ) * MIN ( zmt1, zmt2 )   &
+                  &                / ( ztatm(ji,jj) - 35.86  + MAX( 0.e0, zmt3 ) )  )
+               zev = sf(jp_humi)%fnow(ji,jj,1) * zes                       ! vapour pressure
+               zqatm(ji,jj) = 0.622 * zev / ( zpatm(ji,jj) - 0.378 * zev ) ! specific humidity
+            ENDDO
+         ENDDO
+      ELSE
+         zqatm(:,:) = sf(jp_humi)%fnow(:,:,1)
+      ENDIF
 
       ! local scalars ( place there for vector optimisation purposes)
@@ -574,5 +754,5 @@
                ! Latent Heat
                qla_ice(ji,jj,jl) = rn_efac * MAX( 0.e0, rhoa * Ls  * Cice * wndm_ice(ji,jj)   &                           
-                  &                         * (  11637800. * EXP( -5897.8 / ptsu(ji,jj,jl) ) / rhoa - sf(jp_humi)%fnow(ji,jj,1)  ) )
+                  &                         * (  11637800. * EXP( -5897.8 / ptsu(ji,jj,jl) ) / rhoa - zqatm(ji,jj)  ) )
               ! Latent heat sensitivity for ice (Dqla/Dt)
                IF( qla_ice(ji,jj,jl) > 0._wp ) THEN
@@ -659,4 +839,5 @@
       IF( nn_timing == 1 )  CALL timing_stop('blk_ice_core_flx')
       
+      CALL wrk_dealloc( jpi,jpj, zqatm, zpatm, ztatm )
    END SUBROUTINE blk_ice_core_flx
 #endif
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2_crs.F90	(revision 6772)
@@ -61,5 +61,4 @@
    !
    PUBLIC   eos_crs        ! called by step, istate, tranpc and zpsgrd modules
-   PUBLIC   bn2_crs        ! called by step module
    PUBLIC   eos_rab_crs    ! called by ldfslp, zdfddm, trabbl
    PUBLIC   eos_init_crs   ! called by istate module
@@ -392,5 +391,5 @@
                DO ji = 1, jpi_crs
                   !
-                  zh  = gdept_crs(ji,jj,jk) * r1_Z0                                ! depth
+                  zh  = fsdept_crs(ji,jj,jk) * r1_Z0                                ! depth
                   zt  = pts (ji,jj,jk,jp_tem) * r1_T0                           ! temperature
                   zs  = SQRT( ABS( pts(ji,jj,jk,jp_sal) + rdeltaS ) * r1_S0 )   ! square root salinity
@@ -450,5 +449,5 @@
                   zt  = pts (ji,jj,jk,jp_tem) - 10._wp   ! pot. temperature anomaly (t-T0)
                   zs  = pts (ji,jj,jk,jp_sal) - 35._wp   ! abs. salinity anomaly (s-S0)
-                  zh  = gdept_crs(ji,jj,jk)                 ! depth in meters at t-point
+                  zh  = fsdept_crs(ji,jj,jk)                 ! depth in meters at t-point
                   ztm = tmask_crs(ji,jj,jk)                  ! land/sea bottom mask = surf. mask
                   !
@@ -689,60 +688,4 @@
       !
    END SUBROUTINE rab_crs_0d
-
-
-   SUBROUTINE bn2_crs( pts, pab, pn2 )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE bn2  ***
-      !!
-      !! ** Purpose :   Compute the local Brunt-Vaisala frequency at the 
-      !!                time-step of the input arguments
-      !!
-      !! ** Method  :   pn2 = grav * (alpha dk[T] + beta dk[S] ) / e3w
-      !!      where alpha and beta are given in pab, and computed on T-points.
-      !!      N.B. N^2 is set one for all to zero at jk=1 in istate module.
-      !!
-      !! ** Action  :   pn2 : square of the brunt-vaisala frequency at w-point 
-      !!
-      !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk,jpts), INTENT(in   ) ::  pts   ! pot. temperature and salinity   [Celcius,psu]
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk,jpts), INTENT(in   ) ::  pab   ! thermal/haline expansion coef.  [Celcius-1,psu-1]
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk     ), INTENT(  out) ::  pn2   ! Brunt-Vaisala frequency squared [1/s^2]
-      !
-      INTEGER  ::   ji, jj, jk      ! dummy loop indices
-      REAL(wp) ::   zaw, zbw, zrw   ! local scalars
-      !!----------------------------------------------------------------------
-      !
-      pn2(:,:,:)=0._wp
-
-      IF( nn_timing == 1 ) CALL timing_start('bn2')
-      !
-      DO jk = 2, jpkm1           ! interior points only (2=< jk =< jpkm1 )
-         DO jj = 1, jpj_crs          ! surface and bottom value set to zero one for all in istate.F90
-            DO ji = 1, jpi_crs
-               !zrw =   ( gdepw_crs(ji,jj,jk  ) - gdept_crs(ji,jj,jk) )   &
-               !   &  / ( gdept_crs(ji,jj,jk-1) - gdept_crs(ji,jj,jk) ) 
-               zrw =   gdepw_crs(ji,jj,jk  ) - gdept_crs(ji,jj,jk)    
-               !?IF( gdept_crs(ji,jj,jk-1) - gdept_crs(ji,jj,jk) .NE. 0._wp )THEN
-               IF( gdept_crs(ji,jj,jk-1) - gdept_crs(ji,jj,jk) .LT. 0._wp )THEN
-                  zrw = zrw  / ( gdept_crs(ji,jj,jk-1) - gdept_crs(ji,jj,jk) ) 
-               ELSE
-                  zrw = 0._wp
-               ENDIF
-               !
-               zaw = pab(ji,jj,jk,jp_tem) * (1._wp - zrw) + pab(ji,jj,jk-1,jp_tem) * zrw 
-               zbw = pab(ji,jj,jk,jp_sal) * (1._wp - zrw) + pab(ji,jj,jk-1,jp_sal) * zrw
-               !
-               IF( e3w_max_crs(ji,jj,jk) .NE. 0._wp ) THEN
-                  pn2(ji,jj,jk) = grav * (  zaw * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) )     &
-                     &                    - zbw * ( pts(ji,jj,jk-1,jp_sal) - pts(ji,jj,jk,jp_sal) )  )  &
-                  &                    * tmask_crs(ji,jj,jk)  / e3w_max_crs(ji,jj,jk)
-               ENDIF
-            END DO
-         END DO
-      END DO
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('bn2')
-      !
-   END SUBROUTINE bn2_crs
 
    SUBROUTINE eos_init_crs
